//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "MixInstDlg.h"
#include "Mixmaster.h"
#include "FileMan.h"
#include "wipedlgs.h"
#include "QSver.h"
#include "DirBrow.h"
#include "WaitDlg.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMixInstallDlg *MixInstallDlg;
//---------------------------------------------------------------------------
int __fastcall RunMixmasterInstall(AnsiString mixfile)
{
   MixInstallDlg = new TMixInstallDlg(AppMainForm,mixfile);
   MixInstallDlg->ShowModal();
   int mrResult = MixInstallDlg->ModalResult;
   delete MixInstallDlg;
   return mrResult;
}
//---------------------------------------------------------------------------
//__fastcall TMouseTime::TMouseTime(int rnd0, int rnd1, int rnd2, int rnd3)
//{
//   rnd[0]=rnd0; rnd[1]=rnd1; rnd[2]=rnd2; rnd[3]=rnd3;
//   GetSystemTime(&time);
//}
//---------------------------------------------------------------------------
__fastcall TMixInstallDlg::TMixInstallDlg(TComponent* Owner)
  : TForm(Owner)
{
   /*AnsiString mixzip;
   Label1->Caption = "No Mixmaster to install!";
   TStringList *files = new TStringList(); files->Sorted = true;
   GetFilenames(files,AppDir+"mix29*.zip");
   if (!files->Count) GetFilenames(files,AppDir+"mix3*.zip");
   if ( files->Count)
   {
      MixDirectory->Text = AnsiString("C:\\Program Files\\Mixmaster");
      MixZip = files->Strings[0];
      mixzip = ExtractFileName(MixZip);
      MixVer = GetParam(0,mixzip,".").SubString(4,32); MixVer.Insert(".",2);
      Label1->Caption = "Mixmaster "+MixVer;
      // startup page
      RichEdit1->Lines->Strings[0] =
         "On examining your system, I've found the file '"+mixzip+"' in the";
      RichEdit1->Lines->Strings[1] =
         AppName+" home directory. I can install it now!";
      // mix directory
      RichEdit2->Lines->Strings[5] =
         "'mix.cfg' and "+AppName+" looks for 'mixlib.dll' and 'libeay32.dll'.";
   }
   delete files;

   pencoords = new TStringList();
   PaintBox1->Canvas->Pen->Color = clBlue;
   PaintBox1->Align = alClient;
   pendown = false;

   Notebook1->PageIndex = 0;
   ActiveControl = NextBtn;
   entropy_achieved = 0;*/
}
//---------------------------------------------------------------------------
__fastcall TMixInstallDlg::TMixInstallDlg(TComponent* Owner, AnsiString &Mixzip)
  : TForm(Owner)
{
   Label1->Caption = "No Mixmaster to install!";
   AnsiString mixzip,dir,initialdir="C:\\Program Files\\Mixmaster";
   TStringList *files = new TStringList(); files->Sorted = true;

   if (FileExists(Mixzip)) files->Add(Mixzip); // hand delivered mixzip file
   else GetFilenames(files,AppDir+"mix29*.zip"); // otherwise search for mixzip
   if (!files->Count) GetFilenames(files,AppDir+"mix3*.zip"); // maybe here too
   if ( files->Count)
   {
      TRegistry *reg = new TRegistry();
      if (reg->OpenKey(MixKey,false)) dir = reg->ReadString("MixDir");
      MixDirectory->Text = dir.IsEmpty() ? initialdir : dir;
      delete reg;

      MixZip = files->Strings[0];
      mixzip = ExtractFileName(MixZip);
      MixVer = GetParam(0,mixzip,".").SubString(4,32); MixVer.Insert(".",2);
      Label1->Caption = "Mixmaster "+MixVer;
      // startup page
      if (FileExists(Mixzip))
      {
         RichEdit1->Lines->Strings[0] =
            "The mixmaster update file '"+mixzip+"' is downloaded and currently";
         RichEdit1->Lines->Strings[1] =
            "in the QuickSilver 'updates' subdirectory.";
      }
      else
      {
         RichEdit1->Lines->Strings[0] =
            "On examining your system, I've found the file '"+mixzip+"' in the";
         RichEdit1->Lines->Strings[1] =
            AppName+" home directory. I can install it now!";
      }
      // mix directory
      RichEdit2->Lines->Strings[5] =
         "'mix.cfg' and "+AppName+" looks for 'mixlib.dll' and 'libeay32.dll'.";
   }
   delete files;

   pencoords = new TStringList();
   PaintBox1->Canvas->Pen->Color = clBlue;
   PaintBox1->Align = alClient;
   pendown = false;

   Notebook1->PageIndex = 0;
   ActiveControl = NextBtn;
   entropy_achieved = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel)
   {
      if (CancelBtn->Caption=="Exit")
      {
         if (!CancelBtn->Enabled) MyBeep(MB_OK);
         CanClose = false;
         return;
      }
      else
      {
         if (MsgBoxHwnd(Handle,"Quit without installing Mixmaster?","Mixmaster Setup",MB_YESNO)==IDNO)
         {
            CanClose = false;
            return;
         }
      }
   }
   if (hMixLib) FreeLibrary(hMixLib);
   delete pencoords;
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::BrowseBtnClick(TObject *Sender)
{
   AnsiString dir = GetDirectoryPath(this,MixCfg);
   if (dir!="cancel") MixDirectory->Text = dir;
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::SetCursor(int onpage)
{
   switch (onpage)
   {
      case 1:
//         ActiveControl = MixDirectory;
         break;
      case 2:
         Memo1->Clear();
         Memo1->Lines->Add(AnsiString("Directory = ")+MixDirectory->Text.LowerCase());
         Memo1->Lines->Add(AnsiString("ClientOnly = ")+(ClientBox->Checked?"yes":"no"));
//         ActiveControl = Panel1;
         break;
      case 3:
         Label1->Caption = "One Last Item!";
         CancelBtn->Enabled = false;
//         ActiveControl = Panel2;
         break;
      default:
//         ActiveControl = Panel1;
         break;
   }
   NextBtn->Caption = onpage==2 || onpage==3 ? "Install":"Next";
   CancelBtn->Caption = onpage==3 ? "Exit":"Cancel";
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::BackBtnClick(TObject *Sender)
{
   Notebook1->PageIndex--;
   BackBtn->Enabled = Notebook1->PageIndex > 0 && Notebook1->PageIndex < 3;
   NextBtn->Enabled = Notebook1->ActivePage != "RandSeed";
   SetCursor(Notebook1->PageIndex);
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::CancelBtnClick(TObject *Sender)
{
   if (CancelBtn->Caption=="Exit")
   {
      Sleep(200); Hide(); Sleep(200);
      MsgBoxHwnd(Handle,
         s("Mixmaster successfully installed!"),
        "Mixmaster Setup",MB_OK
      );
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::NextBtnClick(TObject *Sender)
{
   if (NextBtn->Caption=="Install")
   {
      if (MsgBoxHwnd(Handle,"Install mixmaster now?","Confirm",MB_OKCANCEL)==IDCANCEL)
      {
         //EnableButtons(true,true,true);
         return;
      }
      EnableButtons(false,false,false);
      if (!DoWaitDlg("Mixmaster","...installing mixmaster...",this))
      {
         EnableButtons(true,false,true);
         return;
      }
      if (!InstallMixmaster())
      {
         MsgBoxHwnd(Handle,"Mixmaster install FAILED!",AppName,MB_OK);
         EnableButtons(true,false,true);
         return;
      }
   }

   Notebook1->PageIndex++;
   BackBtn->Enabled = Notebook1->PageIndex > 0 && Notebook1->PageIndex < 3;
   NextBtn->Enabled = Notebook1->ActivePage != "RandSeed";
   SetCursor(Notebook1->PageIndex);
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::EnableButtons(bool back, bool next, bool cancel)
{
   CancelBtn->Enabled = cancel;
   NextBtn->Enabled = next;
   BackBtn->Enabled = back;
}
//---------------------------------------------------------------------------
bool __fastcall TMixInstallDlg::InstallMixmaster()
{
   Cursor = crHourGlass;
   Application->ProcessMessages(); Sleep(200);
   RichEdit1->Visible = false;

   AnsiString mixCfg = MixCfg,
   unzipApp = UnzipApp,
   appdir = AddBackslash(GetCurrentDir());
   MixDir = AddBackslash(MixDirectory->Text);
   if (!CreateMixDirectory(MixDir)) return false;
   if (appdir!=MixDir) SetCurrentDir(MixDir);

   bool ok = false;
   if (!CopyFile(MixZip.c_str(),AnsiString(MixDir+ExtractFileName(MixZip)).c_str(), false))
      MsgBoxHwnd(Handle,"System Error: "+GetLastErrorStr(),"File Copy Failed",MB_OK);
   else
   {
      try {
         if (UnpackZipTools(unzipApp) && UnzipMix(unzipApp,mixCfg,MixZip,MixDir))
         {
            if (ClientBox->Checked) ProcessMixCfg(mixCfg);
            ok = true;
         }
      }
      catch (...) {
         MsgBoxHwnd(Handle,"Exception occurred during mixmaster install!","Fatal Error",MB_OK);
         if (GetCurrentDir()!=appdir) SetCurrentDir(appdir);
      }
   }
   if (!ok) return ok;

   hMixLib = LoadLibrary("mixlib.dll");
   if (!hMixLib)
      MsgBoxHwnd(Handle,"Unable to load library: mixlib.dll","Install Failed",MB_OK);
   if (GetCurrentDir()!=appdir) SetCurrentDir(appdir);

   AnsiString mlist,mring,mtype,clist,cring;
   mlist=MixDir+"mlist.txt"; if (FileExists(mlist)) zapfile(mlist,1);
   mring=MixDir+"pubring.mix"; if (FileExists(mring)) zapfile(mring,1);
   mtype=MixDir+"type2.list"; if (FileExists(mtype)) zapfile(mtype,1);
   clist=MixDir+"rlist.txt"; if (FileExists(clist)) zapfile(clist,1);
   cring=MixDir+"pubring.asc"; if (FileExists(cring)) zapfile(cring,1);
   Cursor = crDefault;

   return ok && hMixLib;
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::PaintBox1MouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y)
{
   PaintBox1->Canvas->MoveTo(X,Y);
   pencoords->Add(AnsiString(X)+","+AnsiString(Y));
   pendown = true;
}
//---------------------------------------------------------------------------
/*void __fastcall TMixInstallDlg::Rnd_Mouse_Store(int xpos, int ypos)
{
   int newx,newy,newdx,newdy;
   static int x,y,dx,dy;

   newx = xpos;
   newy = ypos;
   newdx = x-newx;
   newdy = y-newy;
   if (dx != 0 && dy != 0 && dx-newdx != 0 && dy-newdy != 0) entropy++;
   x = newx; y = newy; dx = newdx; dy = newdy;
   mousetime->Add(new TMouseTime(x,y,dx,dy));
}*/
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::PaintPercent()
{
   CancelBtn->Enabled = entropy_achieved >= 100; if (CancelBtn->Enabled) MyBeep(MB_OK);
   char pcnt[32]; sprintf(pcnt,"%3.0f",entropy_achieved);
   AnsiString percent = AnsiString(pcnt)+"%";

   TCanvas *canvas = PaintBox1->Canvas;
   int X = canvas->PenPos.x;
   int Y = canvas->PenPos.y;
   canvas->Font->Color = clRed;
   canvas->TextOut(Panel2->Width-(canvas->TextWidth(percent)+8),4,percent);
   canvas->MoveTo(X,Y);
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::PaintBox1MouseMove(TObject *Sender,
  TShiftState Shift, int X, int Y)
{
//   Rnd_Mouse_Store(X,Y);
   if (pendown)
   {
      pencoords->Add(AnsiString(X)+","+AnsiString(Y));
      PaintBox1->Canvas->LineTo(X,Y);
   }
   entropy_achieved = rnd_mouse(WM_MOUSEMOVE,0,MAKELONG(X,Y));//(double)entropy/(double)ENTROPYNEEDED*100;
   PaintPercent();
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::PaintBox1MouseUp(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y)
{
   pendown = false;
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::PaintBox1Paint(TObject *Sender)
{
   for (int i=0; i<pencoords->Count; i++)
   {
      AnsiString s = pencoords->Strings[i];
      if (i==0)
         PaintBox1->Canvas->MoveTo(
            GetParam(0,s,",").ToInt(), GetParam(1,s,",").ToInt()
         );
      else
         PaintBox1->Canvas->LineTo(
            GetParam(0,s,",").ToInt(), GetParam(1,s,",").ToInt()
         );
   }
   PaintPercent();
}
//---------------------------------------------------------------------------
void __fastcall TMixInstallDlg::ProcessMixCfg(AnsiString mixcfg)
{
   if (FileExists(mixcfg))
      rename(mixcfg.c_str(),AnsiString(mixcfg+OrgExt).c_str());
   TStringList *cfg = new TStringList();
   // if client only is checked, install custom cfg.
   if (ClientBox->Checked)
   {
      if (!AppDataExists(MixValues+PS+MixClientCfg,cfg)) cfg->Add(DefMixCfg);
      cfg->SaveToFile(mixcfg);
   }
   // set REMAIL to 'n' for org copy too
   if (FileExists(mixcfg+OrgExt))
   {
      // set 'remail y' line to 'remail n'
      cfg->LoadFromFile(mixcfg+OrgExt);
      for (int i=0; i<cfg->Count; i++)
      {
         AnsiString rem = cfg->Strings[i].TrimLeft().SubString(1,7).TrimRight();
         if (rem.LowerCase()=="remail")
         {
            cfg->Strings[i] = "REMAIL n";
            break;
         }
      }
      cfg->SaveToFile(mixcfg+OrgExt);
   }
   delete cfg;
}
//---------------------------------------------------------------------------
bool __fastcall TMixInstallDlg::CreateMixDirectory(AnsiString mixdir)
{
   mixdir = RemoveBackslash(mixdir);
   if (!DirectoryExists(mixdir))
   {
      ForceDirectories(mixdir);
      if (!DirectoryExists(mixdir))
      {
         MsgBoxHwnd(Handle,
            AnsiString("Unable to create directory:\n")+
            AnsiString( mixdir+"\n\n")+
            AnsiString("Please specify directory again."),
            AppName,
            MB_OK
         );
         return false;
      }
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixInstallDlg::UnpackZipTools(AnsiString &unzipper)
{
   bool ok;
   TDataBuf *buf = new TDataBuf();
   GetAppBinary(DatExePath+PS+unzipper,buf,AppIni);
   if (buf->length) buf->SaveToFile(unzipper);
   ok = buf->length>0;
   delete buf;
   if (!ok)
      MsgBoxHwnd(Handle,"Problem getting unzip tool from "+AppIni,"Install Failed",MB_OK);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixInstallDlg::UnzipMix(AnsiString &unzipper, AnsiString &mixcfg,
   AnsiString &mixzip, AnsiString &mixdir)
{
   if (!FileExists(unzipper)) return false;

   bool ok = false;
   TStringList *cfg = NULL;
   if (FileExists(mixcfg)) // may not be virgin install...files may exist...huh????
   {
      cfg = new TStringList(); cfg->LoadFromFile(mixcfg); // copy then delete as test
      zapfile(mixcfg,1);                         // for unzipping new copy
   }
   AnsiString thefile,thedir = AddBackslash(mixdir);
   // prepare stringlist for uninstdata
   TStringList *uninstdat = new TStringList();
   uninstdat->Sorted = true;
   uninstdat->Duplicates = dupIgnore;
   if (FileExists(thedir+UninstDat))
      uninstdat->LoadFromFile(thedir+UninstDat);
   int beforecount=uninstdat->Count;
   // get filenames exist before unzip
   TStringList *prev = new TStringList();
   GetFilenames(prev,thedir+"*.*");
   for (int i=0; i<prev->Count; i++)
      prev->Strings[i] = prev->Strings[i].LowerCase();

   AnsiString Mixzip = ExtractFileName(mixzip);
   ExecAndWait95(unzipper+" -ojaqq "+Mixzip+" *.*",SW_MINIMIZE);

   if (FileExists(unzipper)) zapfile(unzipper,1);
   if (FileExists(mixcfg)) // success
   {
      TRegistry *reg = new TRegistry();
      if (reg->OpenKey(MixKey,true)) reg->WriteString("MixDir",RemoveBackslash(mixdir));
      TStringList *tmp = new TStringList();
      GetFilenames(tmp,thedir+"*.*");
      for (int i=0; i<tmp->Count; i++)
      {
         thefile = tmp->Strings[i].LowerCase();
         if (prev->IndexOf(thefile)<0) uninstdat->Add(thefile);
      }
      delete tmp;
      delete reg;
      // add the mix distribution file to QS uninst.dat
      TStringList *uninstapp = new TStringList();
      uninstapp->Sorted = true;
      uninstapp->Duplicates = dupIgnore;
      if (FileExists(AppDir+UninstDat))
         uninstapp->LoadFromFile(AppDir+UninstDat);
      uninstapp->Add(s(AppDir+"updates\\"+ExtractFileName(Mixzip)).LowerCase());
      uninstapp->SaveToFile(AppDir+UninstDat);
      delete uninstapp;
      ok = true;
   }
   else // failed
   {
      MsgBoxHwnd(Handle,"Unable to unzip "+ExtractFileName(mixzip),AppName,MB_OK);
      if (cfg) cfg->SaveToFile(mixcfg); // set things back to original state
   }

   if (uninstdat->Count>beforecount)
      uninstdat->SaveToFile(thedir+UninstDat);
   delete uninstdat;
   delete prev;

   if (cfg) delete cfg;
   return ok;
}
//---------------------------------------------------------------------------
